package fr.smallcrew.rest.wadl;

import fr.smallcrew.rest.data.wadl.Application;
import fr.smallcrew.rest.view.RestViewResolver;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerMapping;

import javax.servlet.http.HttpServletRequest;

@Controller
@RequestMapping("/wadl")
public class WadlController {
  @Autowired
  private RequestMappingHandlerMapping handlerMapping;

  @Autowired
  private RestViewResolver viewResolver;

  @RequestMapping(method = RequestMethod.GET)
  public Application get(HttpServletRequest request) {
    return ApplicationBuilder.from(request, handlerMapping, viewResolver.getMediaTypes()).build();
  }
}