package fr.smallcrew.rest.controller;

public interface CrudController<T, ID> {
  void create(T data);

  T update(T data);

  void delete(ID id);

  void deleteList(String idsToSplit);

  T get(ID id);
}
