package fr.smallcrew.rest.data;

public class PrimitiveValue {
  private final Object value;

  private PrimitiveValue(Object value) {
    this.value = value;
  }

  public Object getValue() {
    return value;
  }

  public static PrimitiveValue from(String value) {
    return new PrimitiveValue(value);
  }

  public static PrimitiveValue from(Number value) {
    return new PrimitiveValue(value);
  }

  public static PrimitiveValue from(Boolean value) {
    return new PrimitiveValue(value);
  }

  public static PrimitiveValue from(Byte value) {
    return new PrimitiveValue(value);
  }

  public static PrimitiveValue from(Character value) {
    return new PrimitiveValue(value);
  }
}
