package fr.smallcrew.rest.data;

import org.springframework.data.domain.Sort;

public class WebSortOrder {
  private String direction;
  private String property;
  private boolean ascending;

  public WebSortOrder() {
  }

  public WebSortOrder(Sort.Order order) {
    direction = order.getDirection().name();
    property = order.getProperty();
    ascending = order.isAscending();
  }

  public String getDirection() {
    return direction;
  }

  public void setDirection(String direction) {
    this.direction = direction;
  }

  public String getProperty() {
    return property;
  }

  public void setProperty(String property) {
    this.property = property;
  }

  public boolean isAscending() {
    return ascending;
  }

  public void setAscending(boolean ascending) {
    this.ascending = ascending;
  }
}
