package fr.smallcrew.rest.servlet.filter;

import org.springframework.web.filter.CharacterEncodingFilter;

import javax.servlet.annotation.WebFilter;
import javax.servlet.annotation.WebInitParam;

@WebFilter(urlPatterns = "/api/*", initParams = {
  @WebInitParam(name = "encoding", value = "UTF-8"),
  @WebInitParam(name = "forceEncoding", value = "true")
})
public class CustomCharacterEncodingFilter extends CharacterEncodingFilter {
}
